import { LRParser } from '@lezer/lr';
import { LRLanguage, HighlightStyle, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "#`OVQPOOOVQPO'#ClQhQPOOOOQO'#Ck'#CkOmQPO'#CkOrQPO,59WOVQPO,59XOzQPO'#CeOOQO,59V,59VOOQO1G.r1G.rOOQO1G.s1G.sO!RQPO'#CnO!^QPO,59POVQPO'#CgO!cQPO,59YOOQO1G.k1G.kO!kQPO,59ROOQO-E6e-E6e",
  stateData: "!y~O^OS~OQRORROSROTPOWSO~OVUO~OTVO~OUXOVUO~OUbP~PVOVUOY]OUbX~OU_O~OY]OUba~OVUOUZaYZa~OVR~",
  goto: "!WcPPPPPPPPPdPgPPPm||!TRWSQ^ZRa^QQOQTPQYUQZVR`]ZROPUV]R[V",
  nodeNames: "⚠ NuFormula String Number Item ( ) Operator Keyword ArgList Comma",
  maxTerm: 18,
  nodeProps: [
    ["closedBy", 5,")"],
    ["openedBy", 6,"("]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: ")t~RcXY!^YZ!^]^!^pq!^rs!cxy${yz%Qz{%V{|%[|}&Q}!O%[!O!P%g!P!Q%V!Q![%u!^!_&V!_!`%V!`!a&b!c!}&j#o#p&r~!cO^~~!fWpq!cqr!crs#Os#O!c#O#P#T#P;'S!c;'S;=`$u<%lO!c~#TOQ~~#WXrs!c!P!Q!c#O#P!c#U#V!c#Y#Z!c#b#c!c#f#g!c#h#i!c#i#j#s~#vR!Q![$P!c!i$P#T#Z$P~$SR!Q![$]!c!i$]#T#Z$]~$`R!Q![$i!c!i$i#T#Z$i~$lR!Q![!c!c!i!c#T#Z!c~$xP;=`<%l!c~%QOT~~%VOU~~%[OV~~%aQV~!O!P%g!Q![%u~%jP!Q![%m~%rPR~!Q![%m~%zQR~!O!P%m!Q![%u~&VOY~~&[QV~!_!`%V!`!a%V~&gPV~!_!`%V~&oPW~!c!}&j~&uR!Q!['O!c!i'O#T#Z'O~'RS}!O'_!Q!['O!c!i'O#T#Z'O~'bR!Q!['k!c!i'k#T#Z'k~'nS}!O'z!Q!['k!c!i'k#T#Z'k~'}R!Q![(W!c!i(W#T#Z(W~(ZS}!O(g!Q![(W!c!i(W#T#Z(W~(jR!Q![(s!c!i(s#T#Z(s~(vS}!O)S!Q![(s!c!i(s#T#Z(s~)VR!Q![)`!c!i)`#T#Z)`~)cS!Q![)`!c!i)`#T#Z)`#q#r)o~)tOS~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 84
});

// 定義語言
const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                Operator: tags.operator,
                Item: tags.variableName,
                "( )": tags.paren,
                Comma: tags.separator,
            }),
        ],
    }),
});
// 語言標籤樣式
const nuformulaHighlightStyle = HighlightStyle.define([
    { tag: tags.keyword, color: "#B157D0" },
    { tag: tags.string, color: "#F7A452" },
    { tag: tags.number, color: "#5C9CE5" },
    { tag: tags.operator, color: "#404040" },
    { tag: tags.variableName, color: "#6E7796" },
]);
// 輸出語言
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula, nuformulaHighlightStyle };
